%{
	#include <stdio.h>
	
	struct lista {
		int value;
		char* ime;
		struct lista* next;
	};
	
	struct lista* glava;
%}
%union {
	int intPolje;
	char* varPolje;
};
%token <intPolje>T_Int <varPolje>T_Var
%type <intPolje>exp
%left '+' '-'
%left '*' '/'

%%
S : S exp '\n'		{ printf("=%d\n", $2);			}			
	|
;

exp : T_Int			{ $$ = $1;    					}
	| T_Var			{
						//lookup
						struct lista* temp = glava;
						int nadjen = 0;
						while (temp != NULL) {
							if(strcmp($1, temp->ime) == 0){
								nadjen = 1;
								break;
							}
							temp = temp->next;
						}
						if(nadjen == 1){
							$$ = temp->value;
						} else {
							$$ = 0;
						}
						
					}
	| T_Var '=' T_Int {
						//1. postoji li T_Int u glava
						struct lista* temp = glava;
						int nadjen = 0;
						while (temp != NULL) {
							if(strcmp($1, temp->ime) == 0){
								nadjen = 1;
								break;
							}
							temp = temp->next;
						}
						if(nadjen == 1){
							temp->value = $3;
						} else {
							struct lista* novi = (struct lista*) malloc (sizeof(struct lista));
							novi->ime = strdup($1);
							novi->value = $3;
							novi->next = glava;
							glava = novi;
						}
						
					}
					
	| exp '+' exp 	{ $$ = $1 + $3;   				}
	| exp '-' exp 	{ $$ = $1 - $3;					}
	| exp '*' exp 	{ $$ = $1 * $3;   				}
	| exp '/' exp 	{ $$ = $1 / $3;					}

;

%%
int main() {

	if (yyparse() == 0) {
		printf("Ulaz JE ispravan.\n");
	} else {
		printf("Ulaz NIJE ispravan.\n");
	}
}



